diff --git a/ldap/servers/plugins/replication/repl5_replica_config.c b/ldap/servers/plugins/replication/repl5_replica_config.c
index ea430d9..d2c4d31 100644
--- a/ldap/servers/plugins/replication/repl5_replica_config.c
+++ b/ldap/servers/plugins/replication/repl5_replica_config.c
@@ -49,10 +49,10 @@ static int replica_config_post_modify(Slapi_PBlock *pb, Slapi_Entry *e, Slapi_En
 static int replica_config_delete(Slapi_PBlock *pb, Slapi_Entry *e, Slapi_Entry *entryAfter, int *returncode, char *returntext, void *arg);
 static int replica_config_search(Slapi_PBlock *pb, Slapi_Entry *e, Slapi_Entry *entryAfter, int *returncode, char *returntext, void *arg);
 static int replica_cleanall_ruv_task(Slapi_PBlock *pb, Slapi_Entry *e, Slapi_Entry *eAfter, int *returncode, char *returntext, void *arg);
+static int replica_config_change_flags(Replica *r, const char *new_flags, char *returntext, int apply_mods);
 static int replica_config_change_type_and_id(Replica *r, const char *new_type, const char *new_id, char *returntext, int apply_mods);
 static int replica_config_change_updatedn(Replica *r, const LDAPMod *mod, char *returntext, int apply_mods);
 static int replica_config_change_updatedngroup(Replica *r, const LDAPMod *mod, char *returntext, int apply_mods);
-static int replica_config_change_flags(Replica *r, const char *new_flags, char *returntext, int apply_mods);
 static int replica_execute_task(Object *r, const char *task_name, char *returntext, int apply_mods);
 static int replica_execute_cl2ldif_task(Object *r, char *returntext);
 static int replica_execute_ldif2cl_task(Object *r, char *returntext);
@@ -323,6 +323,10 @@ replica_config_modify(Slapi_PBlock *pb,
         */
         char *new_repl_id = NULL;
         char *new_repl_type = NULL;
+        /* we also need to handle the change of repl_flags and enable or disable 
+         * the changelog
+         */
+        char *new_repl_flag = NULL;
 
         if (*returncode != LDAP_SUCCESS)
             break;
@@ -567,6 +571,10 @@ replica_config_modify(Slapi_PBlock *pb,
             slapi_ch_free_string(&new_repl_type);
             agmtlist_notify_all(pb);
         }
+        if (new_repl_flag) {
+            *returncode = replica_config_change_flags(r, new_repl_flag, errortext, apply_mods);
+            slapi_ch_free_string(&new_repl_flag);
+        }
     }
 
 done:
@@ -838,7 +846,7 @@ replica_config_search(Slapi_PBlock *pb,
         Replica *replica;
         object_acquire(mtnode_ext->replica);
         if (cl5GetState() == CL5_STATE_OPEN) {
-            changeCount = cl5GetOperationCount(mtnode_ext->replica);
+            changeCount = cl5GetOperationCount((Replica *)object_get_data(mtnode_ext->replica));
         }
         replica = (Replica *)object_get_data(mtnode_ext->replica);
         if (replica) {
@@ -937,7 +945,7 @@ replica_config_change_type_and_id(Replica *r, const char *new_type, const char *
                     replica_reset_csn_pl(r);
                 }
                 ruv_delete_replica(ruv, oldrid);
-                cl5CleanRUV(oldrid);
+                cl5CleanRUV(oldrid, r);
                 replica_set_csn_assigned(r);
             }
             object_release(ruv_obj);
@@ -999,6 +1007,15 @@ replica_config_change_flags(Replica *r, const char *new_flags, char *returntext
         flags = atol(new_flags);
 
         replica_replace_flags(r, flags);
+        if (replica_is_flag_set(r, REPLICA_LOG_CHANGES) && !(flags&REPLICA_LOG_CHANGES)) {
+            /* the replica no longer maintains a changelog, reset */
+           replica_replace_flags (r, flags);
+           nCL_UnSetReplicaDB(r, NULL);
+        } else if (!replica_is_flag_set(r, REPLICA_LOG_CHANGES) && (flags&REPLICA_LOG_CHANGES)) {
+            /* the replica starts to maintains a changelog, set */
+            replica_replace_flags (r, flags);
+            nCL_SetReplicaDB(r, NULL);
+        }
     }
 
     return LDAP_SUCCESS;
@@ -1117,7 +1134,6 @@ static int
 replica_execute_cl2ldif_task(Object *r, char *returntext)
 {
     int rc;
-    Object *rlist[2];
     Replica *replica;
     char fName[MAXPATHLEN];
     char *clDir = NULL;
@@ -1130,8 +1146,6 @@ replica_execute_cl2ldif_task(Object *r, char *returntext)
         goto bail;
     }
 
-    rlist[0] = r;
-    rlist[1] = NULL;
 
     /* file is stored in the changelog directory and is named
        <replica name>.ldif */
@@ -1151,7 +1165,7 @@ replica_execute_cl2ldif_task(Object *r, char *returntext)
     slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name,
                   "replica_execute_cl2ldif_task - Beginning changelog export of replica \"%s\"\n",
                   replica_get_name(replica));
-    rc = cl5ExportLDIF(fName, rlist);
+    rc = cl5ExportLDIF (fName, replica);
     if (rc == CL5_SUCCESS) {
         slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name,
                       "replica_execute_cl2ldif_task - Finished changelog export of replica \"%s\"\n",
@@ -1176,7 +1190,6 @@ static int
 replica_execute_ldif2cl_task(Object *r, char *returntext)
 {
     int rc, imprc = 0;
-    Object *rlist[2];
     Replica *replica;
     char fName[MAXPATHLEN];
     char *clDir = NULL;
@@ -1190,8 +1203,6 @@ replica_execute_ldif2cl_task(Object *r, char *returntext)
         goto bail;
     }
 
-    rlist[0] = r;
-    rlist[1] = NULL;
 
     /* file is stored in the changelog directory and is named
        <replica name>.ldif */
@@ -1223,7 +1234,7 @@ replica_execute_ldif2cl_task(Object *r, char *returntext)
     slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name,
                   "replica_execute_ldif2cl_task -  Beginning changelog import of replica \"%s\"\n",
                   replica_get_name(replica));
-    imprc = cl5ImportLDIF(clDir, fName, rlist);
+    imprc = cl5ImportLDIF (clDir, fName, replica);
     if (CL5_SUCCESS == imprc) {
         slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name,
                       "replica_execute_ldif2cl_task - Finished changelog import of replica \"%s\"\n",
@@ -1239,7 +1250,7 @@ replica_execute_ldif2cl_task(Object *r, char *returntext)
     }
     changelog5_read_config(&config);
     /* restart changelog */
-    rc = cl5Open(config.dir, &config.dbconfig);
+    rc = cl5Open (&config.dbconfig);
     if (CL5_SUCCESS == rc) {
         rc = LDAP_SUCCESS;
     } else {
@@ -1333,7 +1344,7 @@ replica_execute_cleanruv_task(Object *r, ReplicaId rid, char *returntext __attri
     /*
      *  Clean the changelog RUV's
      */
-    cl5CleanRUV(rid);
+    cl5CleanRUV(rid, replica);
 
     /*
      * Now purge the changelog.  The purging thread will free the purge_data
@@ -1341,8 +1352,7 @@ replica_execute_cleanruv_task(Object *r, ReplicaId rid, char *returntext __attri
     purge_data = (cleanruv_purge_data *)slapi_ch_calloc(1, sizeof(cleanruv_purge_data));
     purge_data->cleaned_rid = rid;
     purge_data->suffix_sdn = replica_get_root(replica);
-    purge_data->replName = (char *)replica_get_name(replica);
-    purge_data->replGen = replica_get_generation(replica);
+    purge_data->replica = replica;
     trigger_cl_purging(purge_data);
 
     if (rc != RUV_SUCCESS) {
diff --git a/ldap/servers/slapd/back-ldbm/back-ldbm.h b/ldap/servers/slapd/back-ldbm/back-ldbm.h
index d2b25a7..bf77648 100644
--- a/ldap/servers/slapd/back-ldbm/back-ldbm.h
+++ b/ldap/servers/slapd/back-ldbm/back-ldbm.h
@@ -747,8 +747,9 @@ typedef struct ldbm_instance
     dblayer_handle *inst_handle_head; /* These are used to maintain a list */
     dblayer_handle *inst_handle_tail; /* of open db handles for this instance */
     PRLock *inst_handle_list_mutex;
-
+    
     DB *inst_id2entry; /* id2entry for this instance. */
+    DB *inst_changelog; /* changelog for this instance. */
 
     perfctrs_private inst_perf_private; /* Private data for the performance counters specific to this instance */
     attrcrypt_state_private *inst_attrcrypt_state_private;
diff --git a/ldap/servers/slapd/back-ldbm/dblayer.c b/ldap/servers/slapd/back-ldbm/dblayer.c
index 5d870e3..2163695 100644
--- a/ldap/servers/slapd/back-ldbm/dblayer.c
+++ b/ldap/servers/slapd/back-ldbm/dblayer.c
@@ -114,7 +114,7 @@
 
 #define NEWDIR_MODE 0755
 #define DB_REGION_PREFIX "__db."
-
+#define BE_CHANGELOG_FILE "changelog"
 static int perf_threadmain(void *param);
 static int checkpoint_threadmain(void *param);
 static int trickle_threadmain(void *param);
@@ -2319,6 +2319,25 @@ done:
 }
 
 int
+dblayer_close_changelog(backend *be)
+{
+    ldbm_instance *inst;
+    DB *pDB = NULL;
+    int return_value = 0;
+
+    PR_ASSERT(NULL != be);
+    inst = (ldbm_instance *) be->be_instance_info;
+    PR_ASSERT(NULL != inst);
+
+    pDB = inst->inst_changelog;
+    if (pDB) {
+        return_value = pDB->close(pDB,0);
+        inst->inst_changelog = NULL;
+    }
+    return return_value;
+}
+
+int
 dblayer_close_indexes(backend *be)
 {
     ldbm_instance *inst;
@@ -2388,6 +2407,7 @@ dblayer_instance_close(backend *be)
     }
 
     return_value = dblayer_close_indexes(be);
+    return_value |= dblayer_close_changelog(be);
 
     /* Now close id2entry if it's open */
     pDB = inst->inst_id2entry;
@@ -2764,9 +2784,11 @@ dblayer_open_file(backend *be, char *indexname, int open_flag, struct attrinfo *
         goto out;
 
     dbp = *ppDB;
-    return_value = _dblayer_set_db_callbacks(priv, dbp, ai);
-    if (return_value)
-        goto out;
+    if (ai) {
+	return_value = _dblayer_set_db_callbacks(priv, dbp, ai);
+	if (return_value)
+	    goto out;
+    }
 
     /* The subname argument allows applications to have
      * subdatabases, i.e., multiple databases inside of a single
@@ -2798,10 +2820,11 @@ dblayer_open_file(backend *be, char *indexname, int open_flag, struct attrinfo *
             goto out;
         }
         dbp = *ppDB;
-        return_value = _dblayer_set_db_callbacks(priv, dbp, ai);
-        if (return_value)
-            goto out;
-
+	if (ai) {
+            return_value = _dblayer_set_db_callbacks(priv, dbp, ai);
+            if (return_value)
+		goto out;
+	}
         slapi_ch_free_string(&abs_file_name);
     }
     DB_OPEN(pENV->dblayer_openflags,
@@ -2944,6 +2967,53 @@ dblayer_get_index_file(backend *be, struct attrinfo *a, DB **ppDB, int open_flag
     return return_value;
 }
 
+int dblayer_get_changelog(backend *be, DB** ppDB, int open_flags)
+{
+  /*
+   */
+  ldbm_instance *inst = (ldbm_instance *) be->be_instance_info;
+  int return_value = -1;
+  DB *pDB = NULL;
+
+  *ppDB = NULL;
+
+  if (inst->inst_changelog) {
+    /* This means that the pointer is valid, so we should return it. */
+    *ppDB = inst->inst_changelog;
+    return 0;
+  }
+
+  /* only one thread should open the chgangelog, we can use the mutex
+   * for opening the index files.
+   */
+  PR_Lock(inst->inst_handle_list_mutex);
+  if (inst->inst_changelog) {
+    /* another thread set the handle while we were waiting on the lock */
+    *ppDB = inst->inst_changelog;
+    PR_Unlock(inst->inst_handle_list_mutex);
+    return 0;
+  }
+
+  /* attrinfo handle is still blank, and we have the mutex: open the
+   * index file and stuff it in the attrinfo.
+   */
+  return_value = dblayer_open_file(be, BE_CHANGELOG_FILE, open_flags,
+                                   NULL, &pDB);
+  if (0 == return_value) {
+      /* Opened it OK */
+      inst->inst_changelog = pDB;
+      /* And, most importantly, return something to the caller!*/
+      *ppDB = pDB;
+  } else {
+    /* Did not open it OK ! */
+    /* Do nothing, because return value and fact that we didn't
+     * store a DB* in the attrinfo is enough
+     */
+  }
+  PR_Unlock(inst->inst_handle_list_mutex);
+
+  return return_value;
+}
 /*
  * Unlock the db lib mutex here if we need to.
  */
@@ -5717,84 +5787,6 @@ out:
     return return_value;
 }
 
-/*
- * Get changelogdir from cn=changelog5,cn=config
- * The value does not have trailing spaces nor slashes.
- * The changelogdir value must be a fullpath.
- */
-static int
-_dblayer_get_changelogdir(struct ldbminfo *li, char **changelogdir)
-{
-    Slapi_PBlock *pb = NULL;
-    Slapi_Entry **entries = NULL;
-    Slapi_Attr *attr = NULL;
-    Slapi_Value *v = NULL;
-    const char *s = NULL;
-    char *attrs[2];
-    int rc = -1;
-
-    if (NULL == li || NULL == changelogdir) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "_dblayer_get_changelogdir", "Invalid arg: "
-                                                   "li: 0x%p, changelogdir: 0x%p\n",
-                      li, changelogdir);
-        return rc;
-    }
-    *changelogdir = NULL;
-
-    pb = slapi_pblock_new();
-    attrs[0] = CHANGELOGDIRATTR;
-    attrs[1] = NULL;
-    slapi_search_internal_set_pb(pb, CHANGELOGENTRY,
-                                 LDAP_SCOPE_BASE, "cn=*", attrs, 0, NULL, NULL,
-                                 li->li_identity, 0);
-    slapi_search_internal_pb(pb);
-    slapi_pblock_get(pb, SLAPI_PLUGIN_INTOP_RESULT, &rc);
-
-    if (LDAP_NO_SUCH_OBJECT == rc) {
-        /* No changelog; Most likely standalone or not a master. */
-        rc = LDAP_SUCCESS;
-        goto bail;
-    }
-    if (LDAP_SUCCESS != rc) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "_dblayer_get_changelogdir", "Failed to search \"%s\"\n", CHANGELOGENTRY);
-        goto bail;
-    }
-    /* rc == LDAP_SUCCESS */
-    slapi_pblock_get(pb, SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES, &entries);
-    if (NULL == entries) {
-        /* No changelog */
-        goto bail;
-    }
-    /* There should be only one entry. */
-    rc = slapi_entry_attr_find(entries[0], CHANGELOGDIRATTR, &attr);
-    if (rc || NULL == attr) {
-        /* No changelog dir */
-        rc = LDAP_SUCCESS;
-        goto bail;
-    }
-    rc = slapi_attr_first_value(attr, &v);
-    if (rc || NULL == v) {
-        /* No changelog dir */
-        rc = LDAP_SUCCESS;
-        goto bail;
-    }
-    rc = LDAP_SUCCESS;
-    s = slapi_value_get_string(v);
-    if (NULL == s) {
-        /* No changelog dir */
-        goto bail;
-    }
-    *changelogdir = slapi_ch_strdup(s);
-    /* Remove trailing spaces and '/' if any */
-    normalize_dir(*changelogdir);
-bail:
-    slapi_free_search_results_internal(pb);
-    slapi_pblock_destroy(pb);
-    return rc;
-}
-
 /* Destination Directory is an absolute pathname */
 int
 dblayer_backup(struct ldbminfo *li, char *dest_dir, Slapi_Task *task)
@@ -5926,46 +5918,6 @@ dblayer_backup(struct ldbminfo *li, char *dest_dir, Slapi_Task *task)
             if (inst_dirp != inst_dir)
                 slapi_ch_free_string(&inst_dirp);
         }
-        /* Get changelogdir, if any */
-        _dblayer_get_changelogdir(li, &changelogdir);
-        if (changelogdir) {
-            /* dest dir for changelog: dest_dir/repl_changelog_backup  */
-            char *changelog_destdir = slapi_ch_smprintf("%s/%s",
-                                                        dest_dir, CHANGELOG_BACKUPDIR);
-            return_value = dblayer_copy_directory(li, task, changelogdir,
-                                                  changelog_destdir,
-                                                  0 /* backup */,
-                                                  &cnt, 0, 0, 1);
-            if (return_value) {
-                slapi_log_err(SLAPI_LOG_ERR,
-                              "dblayer_backup", "Error in copying directory "
-                                                "(%s -> %s): err=%d\n",
-                              changelogdir, changelog_destdir, return_value);
-                if (task) {
-                    slapi_task_log_notice(task,
-                                          "Backup: error in copying directory "
-                                          "(%s -> %s): err=%d\n",
-                                          changelogdir, changelog_destdir, return_value);
-                }
-                slapi_ch_free_string(&changelog_destdir);
-                goto bail;
-            }
-            /* Copy DBVERSION */
-            pathname1 = slapi_ch_smprintf("%s/%s",
-                                          changelogdir, DBVERSION_FILENAME);
-            pathname2 = slapi_ch_smprintf("%s/%s",
-                                          changelog_destdir, DBVERSION_FILENAME);
-            return_value = dblayer_copyfile(pathname1, pathname2,
-                                            0, priv->dblayer_file_mode);
-            slapi_ch_free_string(&pathname2);
-            slapi_ch_free_string(&changelog_destdir);
-            if (0 > return_value) {
-                slapi_log_err(SLAPI_LOG_ERR, "dblayer_backup", "Failed to copy file %s\n", pathname1);
-                slapi_ch_free_string(&pathname1);
-                goto bail;
-            }
-            slapi_ch_free_string(&pathname1);
-        }
         if (priv->dblayer_enable_transactions) {
             /* now, get the list of logfiles that still exist */
             return_value = LOG_ARCHIVE(priv->dblayer_env->dblayer_DB_ENV,
@@ -6477,13 +6429,6 @@ dblayer_restore(struct ldbminfo *li, char *src_dir, Slapi_Task *task, char *bena
             if (!frirestore || strcasecmp(direntry->name, bename) == 0) {
                 tmp_rval = PR_GetFileInfo64(filename1, &info);
                 if (tmp_rval == PR_SUCCESS && PR_FILE_DIRECTORY == info.type) {
-                    /* Is it CHANGELOG_BACKUPDIR? */
-                    if (0 == strcmp(CHANGELOG_BACKUPDIR, direntry->name)) {
-                        /* Yes, this is a changelog backup. */
-                        /* Get the changelog path */
-                        _dblayer_get_changelogdir(li, &changelogdir);
-                        continue;
-                    }
                     inst = ldbm_instance_find_by_name(li, (char *)direntry->name);
                     if (inst == NULL) {
                         slapi_log_err(SLAPI_LOG_ERR,
@@ -7184,6 +7129,22 @@ ldbm_back_get_info(Slapi_Backend *be, int cmd, void **info)
         }
         break;
     }
+    case BACK_INFO_DBENV_CLDB:
+    {
+	ldbm_instance *inst = (ldbm_instance *) be->be_instance_info;
+	if (inst->inst_changelog) {
+	    rc = 0;
+	} else {
+	    DB *db;
+	    rc = dblayer_get_changelog(be, &db,DB_CREATE);
+	}
+	if (rc == 0) {
+	    *(DB **)info = inst->inst_changelog;
+	} else {
+	    *(DB **)info = NULL;
+	}
+        break;
+    }
     case BACK_INFO_DBENV_OPENFLAGS: {
         struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
         if (li) {
diff --git a/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h b/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
index 3327faa..eb59d5a 100644
--- a/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
+++ b/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
@@ -79,6 +79,7 @@ int dblayer_post_close(struct ldbminfo *li, int dbmode);
 int dblayer_instance_close(backend *be);
 int dblayer_get_index_file(backend *be, struct attrinfo *a, DB **ppDB, int create);
 int dblayer_release_index_file(backend *be, struct attrinfo *a, DB *pDB);
+int dblayer_get_changelog(backend *be, DB** ppDB, int create);
 int dblayer_erase_index_file(backend *be, struct attrinfo *a, int no_force_chkpt);
 int dblayer_erase_index_file_nolock(backend *be, struct attrinfo *a, int no_force_chkpt);
 int dblayer_get_id2entry(backend *be, DB **ppDB);
diff --git a/ldap/servers/slapd/slapi-plugin.h b/ldap/servers/slapd/slapi-plugin.h
index 4566202..c4b8c1c 100644
--- a/ldap/servers/slapd/slapi-plugin.h
+++ b/ldap/servers/slapd/slapi-plugin.h
@@ -7717,6 +7717,7 @@ int slapi_check_account_lock(Slapi_PBlock *pb, Slapi_Entry *bind_target_entry, i
  *
  * \note Implemented cmd:
  * BACK_INFO_DBENV - Get the dbenv
+ * BACK_INFO_DBENV_CLBD - Get the changelog db for the backend
  * BACK_INFO_DBENV_OPENFLAGS - Get the dbenv openflags
  * BACK_INFO_INDEXPAGESIZE - Get the index page size
  */
@@ -7754,6 +7755,9 @@ int slapi_back_ctrl_info(Slapi_Backend *be, int cmd, void *info);
 enum
 {
     BACK_INFO_DBENV,               /* Get the dbenv */
+    BACK_INFO_DBENV_CLDB,          /* Get the changelog */
+    BACK_INFO_DBENV_CLDB_REMOVE,   /* Remove the changelog */
+    BACK_INFO_DBENV_CLDB_RESET,    /* Recreate the changelog */
     BACK_INFO_INDEXPAGESIZE,       /* Get the index page size */
     BACK_INFO_DBENV_OPENFLAGS,     /* Get the dbenv openflags */
     BACK_INFO_CRYPT_INIT,          /* Ctrl: clcrypt_init */
diff --git a/ldap/servers/slapd/tools/dbscan.c b/ldap/servers/slapd/tools/dbscan.c
index f4001d2..e4eb1a7 100644
--- a/ldap/servers/slapd/tools/dbscan.c
+++ b/ldap/servers/slapd/tools/dbscan.c
@@ -1044,6 +1044,9 @@ is_changelog(char *filename)
     } else {
         ptr++;
     }
+
+    if (0 == strcmp(ptr,"changelog.db")) return 1;
+
     for (; ptr && *ptr; ptr++) {
         if ('.' == *ptr) {
             if (0 == strncmp(ptr, ".db", 3)) {
-- 
2.9.5

